
{-# LANGUAGE 
    FlexibleInstances
    #-}

module Main where

import Test.Framework (defaultMain, testGroup)
import Test.Framework.Providers.QuickCheck (testProperty)
import Test.QuickCheck

import Music.Score

import Data.List

main = defaultMain tests

tests = [
        testGroup "Sorting Group 1" [
                testProperty "duration :: Score" prop_durationScore,
                testProperty "duration :: Track" prop_durationTrack
            ]
        ]


prop_durationScore a = offset a .-. onset a == duration a
    where 
      types = (
        a :: Score ()
        )

prop_durationTrack a = offset a .-. onset a == duration a
    where 
      types = (
        a :: Track ()
        )
        
